#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "php.h"
#include "php_ini.h"
#include "ext/standard/info.h"

extern zend_module_entry ovl_module_entry;
#define phpext_ovl_ptr &ovl_module_entry

#ifdef PHP_WIN32
#define PHP_OVL_API __declspec(dllexport)
#else
#define PHP_OVL_API
#endif

PHP_MINIT_FUNCTION(ovl);
PHP_FUNCTION(ovl);

static zend_class_entry *ovl_class_entry_ptr;

zend_module_entry ovl_module_entry = {
	STANDARD_MODULE_HEADER,
	"ovl",
	NULL,
	PHP_MINIT(ovl),
	NULL, NULL, NULL, NULL,
	"0.1", /* Replace with version number for your extension */
	STANDARD_MODULE_PROPERTIES
};

#ifdef COMPILE_DL_OVL
ZEND_GET_MODULE(ovl)
#endif

static zend_function_entry php_ovl_class_functions[] = {
	PHP_FE(ovl,    NULL)
	{NULL, NULL, NULL}
};

PHP_MINIT_FUNCTION(ovl)
{
	zend_class_entry ovl_class_entry;
	INIT_CLASS_ENTRY(ovl_class_entry, "ovl", php_ovl_class_functions);
	ovl_class_entry_ptr = zend_register_internal_class(&ovl_class_entry);
	return SUCCESS;
}

int _ovl_property_set(zend_property_reference *prop_ref, zval *value) {
	zend_llist_element *element = prop_ref->elements_list->head;
	zval overloaded_property = ((zend_overloaded_element *)(element->data))->element;

	zval_add_ref(&value);
	add_property_zval(prop_ref->object, Z_STRVAL(overloaded_property), value);
}


zval _ovl_property_get(zend_property_reference *prop_ref) {
	zval result;
	zend_llist_element *element = prop_ref->elements_list->head;
	zval overloaded_property = ((zend_overloaded_element *)(element->data))->element;
	pval **tmp;
			                                                                                                                            
	if(zend_hash_find(Z_OBJPROP_P(prop_ref->object), 
				      Z_STRVAL(overloaded_property), 
					  Z_STRLEN(overloaded_property)+1, (void **)&tmp)!=FAILURE) {
		result = **tmp;
		zval_copy_ctor(&result);
	}
	return result;
}

/* Constructor */
PHP_FUNCTION(ovl) {
	ovl_class_entry_ptr->handle_property_get = (void *)_ovl_property_get;
	ovl_class_entry_ptr->handle_property_set = (void *)_ovl_property_set;
}

/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 * vim600: noet sw=4 ts=4 fdm=marker
 * vim<600: noet sw=4 ts=4
 */
